require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_IO_H)) {
    eval 'sub __SPARC_IO_H () {1;}' unless defined(&__SPARC_IO_H);
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'linux/ioport.ph';
    require 'asm/page.ph';
    require 'asm/system.ph';
    eval 'sub virt_to_bus () { &virt_to_phys;}' unless defined(&virt_to_bus);
    eval 'sub bus_to_virt () { &phys_to_virt;}' unless defined(&bus_to_virt);
    eval 'sub page_to_phys {
        local($page) = @_;
	    eval q((((($page) -  &mem_map) <<  &PAGE_SHIFT)+ &phys_base));
    }' unless defined(&page_to_phys);
    eval 'sub inb_local {
        local($addr) = @_;
	    eval q( &readb($addr));
    }' unless defined(&inb_local);
    eval 'sub inb {
        local($addr) = @_;
	    eval q( &readb($addr));
    }' unless defined(&inb);
    eval 'sub inw {
        local($addr) = @_;
	    eval q( &readw($addr));
    }' unless defined(&inw);
    eval 'sub inl {
        local($addr) = @_;
	    eval q( &readl($addr));
    }' unless defined(&inl);
    eval 'sub inb_p {
        local($addr) = @_;
	    eval q( &readb($addr));
    }' unless defined(&inb_p);
    eval 'sub outb_local {
        local($b, $addr) = @_;
	    eval q( &writeb($b, $addr));
    }' unless defined(&outb_local);
    eval 'sub outb {
        local($b, $addr) = @_;
	    eval q( &writeb($b, $addr));
    }' unless defined(&outb);
    eval 'sub outw {
        local($b, $addr) = @_;
	    eval q( &writew($b, $addr));
    }' unless defined(&outw);
    eval 'sub outl {
        local($b, $addr) = @_;
	    eval q( &writel($b, $addr));
    }' unless defined(&outl);
    eval 'sub outb_p {
        local($b, $addr) = @_;
	    eval q( &writeb($b, $addr));
    }' unless defined(&outb_p);
    eval 'sub IO_SPACE_LIMIT () {0xffffffff;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub sbus_readb {
        local($a) = @_;
	    eval q( &_sbus_readb(($a)));
    }' unless defined(&sbus_readb);
    eval 'sub sbus_readw {
        local($a) = @_;
	    eval q( &_sbus_readw(($a)));
    }' unless defined(&sbus_readw);
    eval 'sub sbus_readl {
        local($a) = @_;
	    eval q( &_sbus_readl(($a)));
    }' unless defined(&sbus_readl);
    eval 'sub sbus_writeb {
        local($v, $a) = @_;
	    eval q( &_sbus_writeb($v, ($a)));
    }' unless defined(&sbus_writeb);
    eval 'sub sbus_writew {
        local($v, $a) = @_;
	    eval q( &_sbus_writew($v, ($a)));
    }' unless defined(&sbus_writew);
    eval 'sub sbus_writel {
        local($v, $a) = @_;
	    eval q( &_sbus_writel($v, ($a)));
    }' unless defined(&sbus_writel);
    if(defined(&__KERNEL__)) {
	eval 'sub ioremap_nocache {
	    local($X,$Y) = @_;
    	    eval q( &ioremap(($X),($Y)));
	}' unless defined(&ioremap_nocache);
	eval 'sub virt_to_phys {
	    local($x) = @_;
    	    eval q( &__pa(($x)));
	}' unless defined(&virt_to_phys);
	eval 'sub phys_to_virt {
	    local($x) = @_;
    	    eval q( &__va(($x)));
	}' unless defined(&phys_to_virt);
	eval 'sub RTC_PORT {
	    local($x) = @_;
    	    eval q(( &rtc_port + ($x)));
	}' unless defined(&RTC_PORT);
	eval 'sub RTC_ALWAYS_BCD () {0;}' unless defined(&RTC_ALWAYS_BCD);
	eval 'sub dma_cache_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
    }
}
1;
