require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_PGTABLE_H)) {
    eval 'sub _SPARC_PGTABLE_H () {1;}' unless defined(&_SPARC_PGTABLE_H);
    require 'linux/config.ph';
    require 'linux/spinlock.ph';
    require 'asm/asi.ph';
    if(defined(&CONFIG_SUN4)) {
	require 'asm/pgtsun4.ph';
    } else {
	require 'asm/pgtsun4c.ph';
    }
    require 'asm/pgtsrmmu.ph';
    require 'asm/vac-ops.ph';
    require 'asm/oplib.ph';
    require 'asm/sbus.ph';
    require 'asm/btfixup.ph';
    require 'asm/system.ph';
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub quick_kernel_fault {
	    local($addr) = @_;
    	    eval q( &BTFIXUP_CALL($addr));
	}' unless defined(&quick_kernel_fault);
	eval 'sub mmu_lockarea {
	    local($vaddr,$len) = @_;
    	    eval q( &BTFIXUP_CALL($vaddr,$len));
	}' unless defined(&mmu_lockarea);
	eval 'sub mmu_unlockarea {
	    local($vaddr,$len) = @_;
    	    eval q( &BTFIXUP_CALL($vaddr,$len));
	}' unless defined(&mmu_unlockarea);
	eval 'sub mmu_get_scsi_one {
	    local($vaddr,$len,$sbus) = @_;
    	    eval q( &BTFIXUP_CALL($vaddr,$len,$sbus));
	}' unless defined(&mmu_get_scsi_one);
	eval 'sub mmu_get_scsi_sgl {
	    local($sg,$sz,$sbus) = @_;
    	    eval q( &BTFIXUP_CALL($sg,$sz,$sbus));
	}' unless defined(&mmu_get_scsi_sgl);
	eval 'sub mmu_release_scsi_one {
	    local($vaddr,$len,$sbus) = @_;
    	    eval q( &BTFIXUP_CALL($vaddr,$len,$sbus));
	}' unless defined(&mmu_release_scsi_one);
	eval 'sub mmu_release_scsi_sgl {
	    local($sg,$sz,$sbus) = @_;
    	    eval q( &BTFIXUP_CALL($sg,$sz,$sbus));
	}' unless defined(&mmu_release_scsi_sgl);
	eval 'sub mmu_map_dma_area {
	    local($va, $ba,$len) = @_;
    	    eval q( &BTFIXUP_CALL($va,$ba,$len));
	}' unless defined(&mmu_map_dma_area);
	eval 'sub mmu_unmap_dma_area {
	    local($ba,$len) = @_;
    	    eval q( &BTFIXUP_CALL($ba,$len));
	}' unless defined(&mmu_unmap_dma_area);
	eval 'sub mmu_translate_dvma {
	    local($ba) = @_;
    	    eval q( &BTFIXUP_CALL($ba));
	}' unless defined(&mmu_translate_dvma);
	eval 'sub VMALLOC_VMADDR {
	    local($x) = @_;
    	    eval q((($x)));
	}' unless defined(&VMALLOC_VMADDR);
	eval 'sub pte_ERROR {
	    local($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pte_ERROR);
	eval 'sub pmd_ERROR {
	    local($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pmd_ERROR);
	eval 'sub pgd_ERROR {
	    local($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pgd_ERROR);
	eval 'sub PMD_SHIFT () { &BTFIXUP_SIMM13( &pmd_shift);}' unless defined(&PMD_SHIFT);
	eval 'sub PMD_SIZE () { &BTFIXUP_SETHI( &pmd_size);}' unless defined(&PMD_SIZE);
	eval 'sub PMD_MASK () { &BTFIXUP_SETHI( &pmd_mask);}' unless defined(&PMD_MASK);
	eval 'sub PMD_ALIGN {
	    local($addr) = @_;
    	    eval q( &pmd_align($addr));
	}' unless defined(&PMD_ALIGN);
	eval 'sub PGDIR_SHIFT () { &BTFIXUP_SIMM13( &pgdir_shift);}' unless defined(&PGDIR_SHIFT);
	eval 'sub PGDIR_SIZE () { &BTFIXUP_SETHI( &pgdir_size);}' unless defined(&PGDIR_SIZE);
	eval 'sub PGDIR_MASK () { &BTFIXUP_SETHI( &pgdir_mask);}' unless defined(&PGDIR_MASK);
	eval 'sub PGDIR_ALIGN () { &pgdir_align( &addr);}' unless defined(&PGDIR_ALIGN);
	eval 'sub PTRS_PER_PTE () { &BTFIXUP_SIMM13( &ptrs_per_pte);}' unless defined(&PTRS_PER_PTE);
	eval 'sub PTRS_PER_PMD () { &BTFIXUP_SIMM13( &ptrs_per_pmd);}' unless defined(&PTRS_PER_PMD);
	eval 'sub PTRS_PER_PGD () { &BTFIXUP_SIMM13( &ptrs_per_pgd);}' unless defined(&PTRS_PER_PGD);
	eval 'sub USER_PTRS_PER_PGD () { &BTFIXUP_SIMM13( &user_ptrs_per_pgd);}' unless defined(&USER_PTRS_PER_PGD);
	eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
	eval 'sub PAGE_NONE () { &__pgprot( &BTFIXUP_INT( &page_none));}' unless defined(&PAGE_NONE);
	eval 'sub PAGE_SHARED () { &__pgprot( &BTFIXUP_INT( &page_shared));}' unless defined(&PAGE_SHARED);
	eval 'sub PAGE_COPY () { &__pgprot( &BTFIXUP_INT( &page_copy));}' unless defined(&PAGE_COPY);
	eval 'sub PAGE_READONLY () { &__pgprot( &BTFIXUP_INT( &page_readonly));}' unless defined(&PAGE_READONLY);
	if(defined(&MODULE)) {
	    eval 'sub PAGE_KERNEL () { &page_kernel;}' unless defined(&PAGE_KERNEL);
	} else {
	    eval 'sub PAGE_KERNEL () { &__pgprot( &BTFIXUP_INT( &page_kernel));}' unless defined(&PAGE_KERNEL);
	}
	eval 'sub __P000 () { &__pgprot(0);}' unless defined(&__P000);
	eval 'sub __P001 () { &__pgprot(0);}' unless defined(&__P001);
	eval 'sub __P010 () { &__pgprot(0);}' unless defined(&__P010);
	eval 'sub __P011 () { &__pgprot(0);}' unless defined(&__P011);
	eval 'sub __P100 () { &__pgprot(0);}' unless defined(&__P100);
	eval 'sub __P101 () { &__pgprot(0);}' unless defined(&__P101);
	eval 'sub __P110 () { &__pgprot(0);}' unless defined(&__P110);
	eval 'sub __P111 () { &__pgprot(0);}' unless defined(&__P111);
	eval 'sub __S000 () { &__pgprot(0);}' unless defined(&__S000);
	eval 'sub __S001 () { &__pgprot(0);}' unless defined(&__S001);
	eval 'sub __S010 () { &__pgprot(0);}' unless defined(&__S010);
	eval 'sub __S011 () { &__pgprot(0);}' unless defined(&__S011);
	eval 'sub __S100 () { &__pgprot(0);}' unless defined(&__S100);
	eval 'sub __S101 () { &__pgprot(0);}' unless defined(&__S101);
	eval 'sub __S110 () { &__pgprot(0);}' unless defined(&__S110);
	eval 'sub __S111 () { &__pgprot(0);}' unless defined(&__S111);
	eval 'sub BAD_PAGETABLE () { &__bad_pagetable();}' unless defined(&BAD_PAGETABLE);
	eval 'sub BAD_PAGE () { &__bad_page();}' unless defined(&BAD_PAGE);
	eval 'sub ZERO_PAGE {
	    local($vaddr) = @_;
    	    eval q(( &mem_map + (( &empty_zero_page -  &PAGE_OFFSET +  &phys_base) >>  &PAGE_SHIFT)));
	}' unless defined(&ZERO_PAGE);
	eval 'sub BITS_PER_PTR () {(8*$sizeof{\'unsigned long\'});}' unless defined(&BITS_PER_PTR);
	eval 'sub PTR_MASK () {(~($sizeof{ &void}-1));}' unless defined(&PTR_MASK);
	eval 'sub SIZEOF_PTR_LOG2 () {2;}' unless defined(&SIZEOF_PTR_LOG2);
	eval 'sub pmd_page {
	    local($pmd) = @_;
    	    eval q( &BTFIXUP_CALL($pmd));
	}' unless defined(&pmd_page);
	eval 'sub pgd_page {
	    local($pgd) = @_;
    	    eval q( &BTFIXUP_CALL($pgd));
	}' unless defined(&pgd_page);
	eval 'sub pte_present {
	    local($pte) = @_;
    	    eval q( &BTFIXUP_CALL($pte));
	}' unless defined(&pte_present);
	eval 'sub pte_clear {
	    local($pte) = @_;
    	    eval q( &BTFIXUP_CALL($pte));
	}' unless defined(&pte_clear);
	eval 'sub pmd_bad {
	    local($pmd) = @_;
    	    eval q( &BTFIXUP_CALL($pmd));
	}' unless defined(&pmd_bad);
	eval 'sub pmd_present {
	    local($pmd) = @_;
    	    eval q( &BTFIXUP_CALL($pmd));
	}' unless defined(&pmd_present);
	eval 'sub pmd_clear {
	    local($pmd) = @_;
    	    eval q( &BTFIXUP_CALL($pmd));
	}' unless defined(&pmd_clear);
	eval 'sub pgd_none {
	    local($pgd) = @_;
    	    eval q( &BTFIXUP_CALL($pgd));
	}' unless defined(&pgd_none);
	eval 'sub pgd_bad {
	    local($pgd) = @_;
    	    eval q( &BTFIXUP_CALL($pgd));
	}' unless defined(&pgd_bad);
	eval 'sub pgd_present {
	    local($pgd) = @_;
    	    eval q( &BTFIXUP_CALL($pgd));
	}' unless defined(&pgd_present);
	eval 'sub pgd_clear {
	    local($pgd) = @_;
    	    eval q( &BTFIXUP_CALL($pgd));
	}' unless defined(&pgd_clear);
	eval 'sub pte_mkwrite {
	    local($pte) = @_;
    	    eval q( &BTFIXUP_CALL($pte));
	}' unless defined(&pte_mkwrite);
	eval 'sub pte_mkdirty {
	    local($pte) = @_;
    	    eval q( &BTFIXUP_CALL($pte));
	}' unless defined(&pte_mkdirty);
	eval 'sub pte_mkyoung {
	    local($pte) = @_;
    	    eval q( &BTFIXUP_CALL($pte));
	}' unless defined(&pte_mkyoung);
	eval 'sub page_pte_prot {
	    local($page, $prot) = @_;
    	    eval q( &mk_pte($page, $prot));
	}' unless defined(&page_pte_prot);
	eval 'sub page_pte {
	    local($page) = @_;
    	    eval q( &page_pte_prot($page,  &__pgprot(0)));
	}' unless defined(&page_pte);
	eval 'sub pte_page {
	    local($pte) = @_;
    	    eval q( &BTFIXUP_CALL($pte));
	}' unless defined(&pte_page);
	eval 'sub mk_pte {
	    local($page,$pgprot) = @_;
    	    eval q( &BTFIXUP_CALL($page,$pgprot));
	}' unless defined(&mk_pte);
	eval 'sub mk_pte_phys {
	    local($page,$pgprot) = @_;
    	    eval q( &BTFIXUP_CALL($page,$pgprot));
	}' unless defined(&mk_pte_phys);
	eval 'sub mk_pte_io {
	    local($page,$pgprot,$space) = @_;
    	    eval q( &BTFIXUP_CALL($page,$pgprot,$space));
	}' unless defined(&mk_pte_io);
	eval 'sub pgd_set {
	    local($pgdp,$pmdp) = @_;
    	    eval q( &BTFIXUP_CALL($pgdp,$pmdp));
	}' unless defined(&pgd_set);
	eval 'sub pmd_set {
	    local($pmdp,$ptep) = @_;
    	    eval q( &BTFIXUP_CALL($pmdp,$ptep));
	}' unless defined(&pmd_set);
	eval 'sub pgd_index {
	    local($address) = @_;
    	    eval q((($address) >>  &PGDIR_SHIFT));
	}' unless defined(&pgd_index);
	eval 'sub pgd_offset {
	    local($mm, $address) = @_;
    	    eval q((($mm)-> &pgd +  &pgd_index($address)));
	}' unless defined(&pgd_offset);
	eval 'sub pgd_offset_k {
	    local($address) = @_;
    	    eval q( &pgd_offset( &init_mm, $address));
	}' unless defined(&pgd_offset_k);
	eval 'sub pmd_offset {
	    local($dir,$addr) = @_;
    	    eval q( &BTFIXUP_CALL($dir,$addr));
	}' unless defined(&pmd_offset);
	eval 'sub pte_offset {
	    local($dir,$addr) = @_;
    	    eval q( &BTFIXUP_CALL($dir,$addr));
	}' unless defined(&pte_offset);
	eval 'sub flush_icache_page {
	    local($vma, $pg) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&flush_icache_page);
	eval 'sub flush_icache_user_range {
	    local($vma,$pg,$adr,$len) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_icache_user_range);
	eval 'sub set_pte {
	    local($ptep,$pteval) = @_;
    	    eval q( &BTFIXUP_CALL($ptep,$pteval));
	}' unless defined(&set_pte);
	eval 'sub mmu_info {
	    local($p) = @_;
    	    eval q( &BTFIXUP_CALL($p));
	}' unless defined(&mmu_info);
	eval 'sub FAULT_CODE_PROT () {0x1;}' unless defined(&FAULT_CODE_PROT);
	eval 'sub FAULT_CODE_WRITE () {0x2;}' unless defined(&FAULT_CODE_WRITE);
	eval 'sub FAULT_CODE_USER () {0x4;}' unless defined(&FAULT_CODE_USER);
	eval 'sub update_mmu_cache {
	    local($vma,$addr,$pte) = @_;
    	    eval q( &BTFIXUP_CALL($vma,$addr,$pte));
	}' unless defined(&update_mmu_cache);
	eval 'sub SWP_TYPE {
	    local($x) = @_;
    	    eval q(((($x). &val >> 2) & 0x7f));
	}' unless defined(&SWP_TYPE);
	eval 'sub SWP_OFFSET {
	    local($x) = @_;
    	    eval q(((($x). &val >> 9) & 0x3ffff));
	}' unless defined(&SWP_OFFSET);
	eval 'sub SWP_ENTRY {
	    local($type,$offset) = @_;
    	    eval q((( &swp_entry_t) { ((($type) & 0x7f) << 2) | ((($offset) & 0x3ffff) << 9) }));
	}' unless defined(&SWP_ENTRY);
	eval 'sub pte_to_swp_entry {
	    local($pte) = @_;
    	    eval q((( &swp_entry_t) {  &pte_val($pte) }));
	}' unless defined(&pte_to_swp_entry);
	eval 'sub swp_entry_to_pte {
	    local($x) = @_;
    	    eval q((( &pte_t) { ($x). &val }));
	}' unless defined(&swp_entry_to_pte);
	eval 'sub NO_CONTEXT () {-1;}' unless defined(&NO_CONTEXT);
	eval 'sub add_to_free_ctxlist {
	    local($entry) = @_;
    	    eval q( &add_to_ctx_list( &ctx_free, $entry));
	}' unless defined(&add_to_free_ctxlist);
	eval 'sub add_to_used_ctxlist {
	    local($entry) = @_;
    	    eval q( &add_to_ctx_list( &ctx_used, $entry));
	}' unless defined(&add_to_used_ctxlist);
	eval 'sub kern_addr_valid {
	    local($addr) = @_;
    	    eval q(( &test_bit( &__pa(($addr))>>20,  &sparc_valid_addr_bitmap)));
	}' unless defined(&kern_addr_valid);
	require 'asm-generic/pgtable.ph';
    }
    eval 'sub HAVE_ARCH_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_UNMAPPED_AREA);
    eval 'sub pgtable_cache_init () {
        eval q( &do { }  &while (0));
    }' unless defined(&pgtable_cache_init);
}
1;
