require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_PGALLOC_H)) {
    eval 'sub _SPARC64_PGALLOC_H () {1;}' unless defined(&_SPARC64_PGALLOC_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    require 'linux/sched.ph';
    require 'asm/page.ph';
    require 'asm/spitfire.ph';
    require 'asm/pgtable.ph';
    eval 'sub flush_cache_mm {
        local($__mm) = @_;
	    eval q( &do {  &if (($__mm) ==  ($current->{mm}))  &flushw_user(); }  &while(0));
    }' unless defined(&flush_cache_mm);
    eval 'sub flush_cache_range {
        local($mm, $start, $end) = @_;
	    eval q( &flush_cache_mm($mm));
    }' unless defined(&flush_cache_range);
    eval 'sub flush_cache_page {
        local($vma, $page) = @_;
	    eval q( &flush_cache_mm(($vma)-> &vm_mm));
    }' unless defined(&flush_cache_page);
    eval 'sub flush_page_to_ram {
        local($page) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_page_to_ram);
    if(defined(&CONFIG_SMP)) {
    } else {
	eval 'sub smp_flush_dcache_page_impl {
	    local($page,$cpu) = @_;
    	    eval q( &flush_dcache_page_impl($page));
	}' unless defined(&smp_flush_dcache_page_impl);
	eval 'sub flush_dcache_page_all {
	    local($mm,$page) = @_;
    	    eval q( &flush_dcache_page_impl($page));
	}' unless defined(&flush_dcache_page_all);
    }
    unless(defined(&CONFIG_SMP)) {
	eval 'sub flush_cache_all () {
	    eval q( &__flush_cache_all());
	}' unless defined(&flush_cache_all);
	eval 'sub flush_tlb_all () {
	    eval q( &__flush_tlb_all());
	}' unless defined(&flush_tlb_all);
	eval 'sub flush_tlb_mm {
	    local($__mm) = @_;
    	    eval q( &do {  &if( &CTX_VALID(($__mm)-> &context))  &__flush_tlb_mm( &CTX_HWBITS(($__mm)-> &context),  &SECONDARY_CONTEXT); }  &while(0));
	}' unless defined(&flush_tlb_mm);
	eval 'sub flush_tlb_range {
	    local($__mm, $start, $end) = @_;
    	    eval q( &do {  &if( &CTX_VALID(($__mm)-> &context)) { \'unsigned long __start\' = ($start) &PAGE_MASK; \'unsigned long __end\' =  &PAGE_ALIGN($end);  &__flush_tlb_range( &CTX_HWBITS(($__mm)-> &context),  &__start,  &SECONDARY_CONTEXT,  &__end,  &PAGE_SIZE, ( &__end -  &__start)); } }  &while(0));
	}' unless defined(&flush_tlb_range);
	eval 'sub flush_tlb_page {
	    local($vma, $page) = @_;
    	    eval q( &do { \'struct mm_struct\' * &__mm = ($vma)-> &vm_mm;  &if( &CTX_VALID( ($__mm->{context})))  &__flush_tlb_page( &CTX_HWBITS( ($__mm->{context})), ($page) &PAGE_MASK,  &SECONDARY_CONTEXT); }  &while(0));
	}' unless defined(&flush_tlb_page);
    } else {
	eval 'sub flush_cache_all () {
	    eval q( &smp_flush_cache_all());
	}' unless defined(&flush_cache_all);
	eval 'sub flush_tlb_all () {
	    eval q( &smp_flush_tlb_all());
	}' unless defined(&flush_tlb_all);
	eval 'sub flush_tlb_mm {
	    local($mm) = @_;
    	    eval q( &smp_flush_tlb_mm($mm));
	}' unless defined(&flush_tlb_mm);
	eval 'sub flush_tlb_range {
	    local($mm, $start, $end) = @_;
    	    eval q( &smp_flush_tlb_range($mm, $start, $end));
	}' unless defined(&flush_tlb_range);
	eval 'sub flush_tlb_page {
	    local($vma, $page) = @_;
    	    eval q( &smp_flush_tlb_page(($vma)-> &vm_mm, $page));
	}' unless defined(&flush_tlb_page);
    }
    if(0) {
    }
    if(defined(&CONFIG_SMP)) {
	eval 'sub pgt_quicklists () { $cpu_data[ &smp_processor_id()];}' unless defined(&pgt_quicklists);
    } else {
    }
    eval 'sub pgd_quicklist () {( ($pgt_quicklists->{pgd_cache}));}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {(0);}' unless defined(&pmd_quicklist);
    eval 'sub pte_quicklist () {( ($pgt_quicklists->{pte_cache}));}' unless defined(&pte_quicklist);
    eval 'sub pgtable_cache_size () {( ($pgt_quicklists->{pgcache_size}));}' unless defined(&pgtable_cache_size);
    eval 'sub pgd_cache_size () {( ($pgt_quicklists->{pgdcache_size}));}' unless defined(&pgd_cache_size);
    unless(defined(&CONFIG_SMP)) {
    } else {
    }
    if(((defined(&L1DCACHE_SIZE) ? &L1DCACHE_SIZE : 0) > (defined(&PAGE_SIZE) ? &PAGE_SIZE : 0)) ) {
	eval 'sub VPTE_COLOR {
	    local($address) = @_;
    	    eval q(((($address) >> ( &PAGE_SHIFT + 10)) & 1));
	}' unless defined(&VPTE_COLOR);
	eval 'sub DCACHE_COLOR {
	    local($address) = @_;
    	    eval q(((($address) >>  &PAGE_SHIFT) & 1));
	}' unless defined(&DCACHE_COLOR);
    } else {
	eval 'sub VPTE_COLOR {
	    local($address) = @_;
    	    eval q(0);
	}' unless defined(&VPTE_COLOR);
	eval 'sub DCACHE_COLOR {
	    local($address) = @_;
    	    eval q(0);
	}' unless defined(&DCACHE_COLOR);
    }
    eval 'sub pgd_populate {
        local($MM, $PGD, $PMD) = @_;
	    eval q( &pgd_set($PGD, $PMD));
    }' unless defined(&pgd_populate);
    eval 'sub pmd_populate {
        local($MM, $PMD, $PTE) = @_;
	    eval q( &pmd_set($PMD, $PTE));
    }' unless defined(&pmd_populate);
    eval 'sub pte_free {
        local($pte) = @_;
	    eval q( &free_pte_fast($pte));
    }' unless defined(&pte_free);
    eval 'sub pmd_free {
        local($pmd) = @_;
	    eval q( &free_pmd_fast($pmd));
    }' unless defined(&pmd_free);
    eval 'sub pgd_free {
        local($pgd) = @_;
	    eval q( &free_pgd_fast($pgd));
    }' unless defined(&pgd_free);
    eval 'sub pgd_alloc {
        local($mm) = @_;
	    eval q( &get_pgd_fast());
    }' unless defined(&pgd_alloc);
}
1;
